#pragma once
#include <cstring>
#include <iostream>
#include <fstream>
#include <stdlib.h>
#ifdef __linux__
    #include <agent/linux/agent.h>
    #include <agent/linux/parse_config_file.h>
    #include <agent/linux/unzip_agent.h>
#endif
#include <boost/filesystem.hpp>
#include <curl/curl.h>
#include <agent/get.h>
#include <json/json.h>

class Curl{
    private:
        CURL *curl;
        std::string curlBuffer;
        CURLcode response;
        long httpCode = 0;
    public:
        bool downloadAgent (Json::Value*, std::string, std::fstream*, Agent*);
        std::string getData () const;
        std::string getMessage () const;

        static size_t callBackDownload(void *ptr, size_t size, size_t nmemb,void* userdata) {
            FILE* stream = (FILE*)userdata;
            
            if (!stream)
                return 0;

             size_t written = fwrite((FILE*)ptr, size, nmemb, stream);
             return written;
        }
};

/*---------------------------------------------------------------------
 * Function: mkdtemp
 * Summary: Create a new and unique temporary directory in /tmp
 */

template<class T>
char *mkdtemp(T *tmpDir);

