#pragma once
#include <map>
#include <agent/linux/agent.h>
#include <agent/linux/parse.h>
#include <json/json.h>

class Conf{
    private:
        std::string dataDir;
        std::string logDir;
        std::string proxyConf;
        std::string webService;

        int delay;
        int daysToExpireLog;
        int updateTries;
        int updateTimeOut;

    public:
        void setDataDir(std::string);
        void setLogDir(std::string);
        void setProxyConf(std::string);
        void setWebService(std::string);

        void setDelay(int);
        void setDaysToExpireLog(int);
        void setUpdateTries(int);
        void setUpdatTimeOut(int);

        std::string getDataDir() const;
        std::string getLogDir() const;
        std::string getProxyConf() const;
        std::string getWebService() const;

        int getDelay() const;
        int getDaysToExpireLog() const;
        int getUpdateTries() const;
        int getUpdateTimeOut() const;

    };

bool parse_config_file(Agent*, Conf*, Json::Value*);
bool set_conf_object(Conf*, Agent*, std::map<std::string, std::string>*);
