#pragma once
#include <map>
#include <agent/linux/agent.h>
#include <agent/linux/parse_config_file.h>
#include <agent/linux/parse.h>
#include <json/json.h>

class Proxy{
    private:
        std::string host;
        std::string port;
        std::string user;
        std::string password;
        bool proxyFile = false;

    public:
        void setHost(std::string);
        void setPort(std::string);
        void setUser(std::string);
        void setPassword(std::string);
        void setProxyFile(bool);

        std::string getHost() const;
        std::string getPort() const;
        std::string getUser() const;
        std::string getPassword() const;

        bool proxyFileIsSet() const;
    };

bool parse_proxy_file(Conf*, Proxy*, Json::Value*);
bool set_proxy_object(Proxy*, std::map<std::string, std::string>*);
