#pragma once
#include <iostream>
#include <fstream>
#include <agent/linux/agent.h>
#include <boost/filesystem.hpp>
#include <zlib/zlib.h>
#include <minizip/unzip.h>
#include <json/json.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <utime.h>

class Unzip{
    private:
        int error;
        unzFile uf;
        std::string path;
        const char* zipFileName;

    public:
        void setError(int);
        void setUF();
        void setPathToUnzipAgent(std::string);
        void setPathToUnzipAgent(std::string, int, std::string);
        void setZipFileName(const char*);

        int getError() const;
        unzFile getUF() const;
        std::string getPathToUnzipAgent() const;
        const char* getZipFileName();

        bool UFIsSet();
        bool zipFileNameIsSet();

        void changeFileDate(const char*, uint32_t);
        int dosDateToTm(uint64_t, struct tm *ptm);
        int makeDir(const char*, Json::Value*, std::fstream*, Agent*);
        bool unzip(Json::Value*, std::fstream*, Agent*);
        bool unzipAllFiles(Json::Value*, std::fstream*, Agent*);
        int unzipCurrentFile(Json::Value*, std::fstream*, Agent*, int);
};
