cmake_minimum_required ( VERSION 2.8.7 )
include (ExternalProject)

project (minizip)

if(UNIX)
  if (NOT MINIZIP)
    # An external project for zlib 
    SET (GIT_URL https://github.com/nmoinvaz/minizip.git) 
    SET (MINIZIP_INSTALL ${CMAKE_CURRENT_BINARY_DIR}) 
    SET (MINIZIP_STATIC  ${CMAKE_BINARY_DIR}/lib/libminizip.a )
    SET (MINIZIP_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/include/minizip)

    ExternalProject_Add(minizip
      DEPENDS zlib     
      PREFIX minizip
      GIT_REPOSITORY ${GIT_URL} 
      INSTALL_DIR ${MINIZIP_INSTALL}
      BUILD_IN_SOURCE 1
      UPDATE_COMMAND ""
      CMAKE_ARGS "-DUSE_AES=OFF;-DCMAKE_INSTALL_PREFIX=${MINIZIP_INSTALL};-DZLIB_ROOT=${ZLIB_ROOT}"  
    )
    
    SET (MINIZIP_LIBRARY "${MINIZIP_INSTALL}")
    ADD_LIBRARY (MINIZIP_LIB STATIC IMPORTED DEPENDS minizip, zlib)
    SET_TARGET_PROPERTIES (MINIZIP_LIB PROPERTIES IMPORTED_LOCATION "${MINIZIP_STATIC}")
  endif()
endif(UNIX)

