cmake_minimum_required ( VERSION 2.8.7 )
include (ExternalProject)

project (zlib)

SET (ZLIB_ROOT ${CMAKE_BINARY_DIR}/zlib/src/zlib)

if(UNIX)
    # An external project for zlib 
    SET (GIT_URL https://github.com/madler/zlib.git) 
    SET (ZLIB_INSTALL ${CMAKE_CURRENT_BINARY_DIR}) 
    SET (ZLIB_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/include/zlib) 
    SET (ZLIB_SHARED  ${CMAKE_BINARY_DIR}/lib/libz.so )

    ExternalProject_Add(zlib     
      PREFIX zlib     
      GIT_REPOSITORY ${GIT_URL}     
      INSTALL_DIR ${ZLIB_INSTALL}     
      PATCH_COMMAND ${CMAKE_COMMAND} -E remove <SOURCE_DIR>/zconf.h     
      BUILD_IN_SOURCE 1         
      CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=<INSTALL_DIR> --includedir=${ZLIB_INCLUDE_DIRS}     
    )

    SET (ZLIB_LIBRARY "${ZLIB_INSTALL}")
    ADD_LIBRARY (ZLIB_LIB SHARED IMPORTED DEPENDS zlib)
    SET_TARGET_PROPERTIES (ZLIB_LIB PROPERTIES IMPORTED_LOCATION "${ZLIB_SHARED}")
endif(UNIX)