/* Copyright (C) 2017 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of simmc-agent
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
#include <agent/linux/agent.h>
#include <string>

/*---------------------------------------------------------------------
 * set Functions
 */

void Agent::setConfDir(std::string dir) {
    this->confDir = this->prefix + dir;
}

void Agent::setDefaultConf(std::string defaultConf) {
    this->defaultConf = this->prefix + defaultConf;
}

void Agent::setDirInstall(std::string d) {
    this->dirInstall = d;
}

void Agent::setLogFile(std::string logDir, std::string file) {
    this->logFile = logDir + file;
}

void Agent::setMessage(std::string m) {
    this->message = m;
}

void Agent::setPrefix(std::string p, int tot) {
    int i = p.size(), count = 0;
    while (i-->-1)
        if (p[i] == '/')
            if (++count == tot)
                break;
    this->prefix = p.substr(0, i);
}

void Agent::setVersion(std::string v) {
    this->version = v;
}

void Agent::setZipName(std::string n) {
    this->zipName = n;
}
/*---------------------------------------------------------------------
 * get Functions
 */

std::string Agent::getConfDir() const {
    return this->confDir;
}

std::string Agent::getDefaultConf() const {
    return  this->defaultConf;
}

std::string Agent::getDirInstall() const {
    return this->dirInstall;
}

std::string Agent::getLogFile() const {
    return this->logFile;
}

std::string Agent::getMessage() const {
    return this->message;
}

std::string Agent::getPrefix() const {
    return this->prefix;
}

std::string Agent::getVersion() const {
    return this->version;
}

std::string Agent::getZipName() const {
    return this->zipName;
}

/* Check if the absolute path of agent was setted */
void Agent::prefixISet() {
    if (this->prefix.size() == 0)
        throw " ERROR: Prefix not set. ";
}

