/* Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of simmc-agent
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */

#include <agent/linux/get_macaddr.h>

std::string get_macaddr() {
    std::fstream file;
    std::string macaddr;

    /* #FIXME The way we are breaking the getline to get the network 
     * interface is not very efficient, because we create a char 
     * array and a string to the same thing.
    */

    char line[40];
    char iface[20];
    char dest[20];
    std::string Iface;
    std::string Destination;
    std::string file_path;

    FILE *fp = fopen("/proc/net/route", "r");
    fgets (line, sizeof(line), fp);    // Skip the first line (column headers).

    /* Loop to found the default network interface*/
    while (fgets(line, sizeof(line), fp)) {

        /* Found the interface name and check that it is default*/
        sscanf(line, "%s %s\n", iface, dest);

        Iface = iface;
        Destination = dest;

        if (Destination == "00000000") {  //  found default network interface
            /* found macaddr with the default network interface*/
            file_path = "/sys/class/net/"+Iface+"/address";
            file.open(file_path, std::ifstream::in);
            if (!file.is_open()) {
                throw std::string("No address file found.");
            }
            getline(file, macaddr);  //  get macaddr
            file.close();
        }
    }
    fclose(fp);

    return macaddr;
}
