/* Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of simmc-agent
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */

#include <agent/linux/get_processor_model.h>

std::string get_processor_model() {

    std::ifstream cpuinfo_file;
    std::string line;
    if (open_file("/proc/cpuinfo", cpuinfo_file)) {
        const std::string key = "model name";
        std::size_t found;

        while (getline(cpuinfo_file, line)) {
            found = line.find(key);
            if (found != std::string::npos) {
                // remove ':' and space at the beginning
                found = line.find(":");
                return (line.substr(found+2));
            }
        }
        throw std::string("Coudn't find model name in /proc/cpuinfo");
    }

    throw std::string("Coudn't open /proc/cpuinfo");
}
