/* Copyright (C) 2004-2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of simmc-agent
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
#include "agent/linux/network_bandwidth.h"
#include <string>
namespace pt = boost::posix_time;

Json::Value get_net_bandwidth() {
    Json::Value net_band;
    Json::Value net_band_all_time;
    Json::Reader reader;
    std::ofstream ofs;
    std::ifstream net_band_file("net_band.json", std::ifstream::binary);
    pt::ptime time;
    std::string str;
    std::fstream time_file("time_now.txt", std::ios::out|std::ios::trunc);
//    net_band_file >> net_band_all_time;
    reader.parse(net_band_file, net_band_all_time , false);
    net_band_file.close();
    unsigned long long b_rec, pack_rec, b_tr, pack_tr; // NOLINT (runtime/int)
    unsigned long long b_rec_allt, pack_rec_allt, b_tr_allt, pack_tr_allt; // NOLINT (runtime/int)

    if (net_band_all_time.isNull()) {
        b_rec_allt = 0;
        pack_rec_allt = 0;
        b_tr_allt = 0;
        pack_tr_allt = 0;
    } else {
        b_rec_allt =
            net_band_all_time["data_net"]["bytes_recived"].asLargestUInt();
        pack_rec_allt =
            net_band_all_time["data_net"]["packets_recived"].asLargestUInt();
        b_tr_allt =
            net_band_all_time["data_net"]["bytes_transmited"].asLargestUInt();
        pack_tr_allt =
            net_band_all_time["data_net"]["packets_tranmited"].asLargestUInt();
    }


    std::string t;
    std::ifstream myfile("/proc/net/dev");
    getline(myfile, t);
    getline(myfile, t);
    getline(myfile, t);

    getline(myfile, t);
    int i = 0;
    int j = 0;
    int len = 0;
    char tmp[20];
    std::string stmp;

    while (t[i] == ' ') {
        ++i;
    }
    while (t[i] != ' ') {
        tmp[j] = t[i];
        tmp[j+1] = '\0';
        stmp = tmp;
        ++i;
        ++j;
    }  // skips "  eth0:"

    if (stmp != "eth0:") {
        i = 0;
        getline(myfile, t);
        while (t[i] == ' ') {
             ++i;
        }
        while (t[i] != ' ') {
            ++i;
        }
    }

    while (t[i] == ' ') {
        ++i;
    }


    j = i;

    while (t[i] != ' ') {
        ++i;
        ++len;
    }

    b_rec = atoll(t.substr(j, len).c_str());
    while (t[i] == ' ')++i;

    j = i;
    len = 0;
    while (t[i] != ' ') {
        ++i;
        ++len;
    }

    pack_rec = atoll(t.substr(j, len).c_str());


    while (t[i] == ' ') {
        ++i;
    }
    while (t[i] != ' ') {
        ++i;
    }  // skips "errs"

    while (t[i] == ' ') {
        ++i;
    }
    while (t[i] != ' ') {
        ++i;
    }  // skips drop

    while (t[i] == ' ') {
        ++i;
    }
    while (t[i] != ' ') {
        ++i;
    }  // skips fifo

    while (t[i] == ' ') {
        ++i;
    }
    while (t[i] != ' ') {
        ++i;
    }  // skips frame

    while (t[i] == ' ') {
       ++i;
    }
    while (t[i] != ' ') {
        ++i;
    }  //  skips compresed

    while (t[i] == ' ') {
        ++i;
    }
    while (t[i] != ' ') {
        ++i;
    }  // skips multicast



    while (t[i] == ' ')++i;

    j = i;
    len = 0;

    while (t[i] != ' ') {
        ++i;
        ++len;
    }
    b_tr = atoll(t.substr(j, len).c_str());


    while (t[i] == ' ')++i;
    j = i;
    len = 0;

    while (t[i] != ' ') {
        ++i;
        ++len;
    }

    pack_tr = atoll(t.substr(j, len).c_str());

    ofs.open("net_band.json", std::ios::trunc);
    net_band_all_time["data_net"]["bytes_recived"] = b_rec;
    net_band_all_time["data_net"]["packets_recived"] = pack_rec;
    net_band_all_time["data_net"]["bytes_transmited"] =  b_tr;
    net_band_all_time["data_net"]["packets_tranmited"] = pack_tr;
    ofs << net_band_all_time;
    ofs.close();
////////////////////////////////////////////////////
    time = pt::second_clock::local_time();
    time_file << time;
    time_file.close();
    time_file.open("time_now.txt", std::ios::in);
    getline(time_file, str);
    time_file.close();
//////////////////////////////////////////////////////////////
    net_band["data_net"]["bytes_recived"] = b_rec - b_rec_allt;
    net_band["data_net"]["packets_recived"] = pack_rec - pack_rec_allt;
    net_band["data_net"]["bytes_transmited"] =  b_tr - b_tr_allt;
    net_band["data_net"]["packets_tranmited"] = pack_tr - pack_tr_allt;
    net_band["data_net"]["collect_time"] = str;
    myfile.close();
    return (net_band);
}
