#!/bin/bash
declare -a ft_users=( user1 user2 user3 user4 )
declare -a ft_dates=( -2d -1d -1d -0d )

for i in $(seq 0 $(( ${#ft_users[@]} -1 )))
do

    ft_user=${ft_users[$i]}
    ft_date=${ft_dates[$i]}

    password=""
    pass=$(perl -e 'print crypt($ARGV[0], "password")' $password)

    useradd -m -p $pass $ft_user
    if [ $? -ne 0 ]
    then
            echo "Failed to add $ft_user!"
    fi

    faketime -f "${ft_date}"  ./login.exp $ft_user &>/dev/null

    if grep -q "openSUSE" /etc/os-release
    then
        userdel -r $ft_user >/dev/null
    else
        deluser --remove-home $ft_user >/dev/null
    fi

    if [ $? -ne 0 ]
    then
            echo "Failed to delete $ft_user!"
    fi

done