#!/usr/bin/env bats

function amount_users() {
    expected_number_of_users=3
    obj=$(cat inventory.json | jq -r '.data_inventory.amount_users')
    [[ "$obj" -eq "$expected_number_of_users" ]] && [[ "$obj" != "null" ]]
}

function mac_address() {
    obj=$(cat inventory.json | jq -r '.data_inventory.mac_address')
    [[ "$obj" =~ ^(..:){5}..$ ]] && [[ "$obj" != "null" ]]
}

function machine_type() {
    os=$(cat inventory.json | jq -r '.data_inventory.os_distro')
    obj=$(cat inventory.json | jq -r '.data_inventory.machine_type')
    ! [[ "$os" =~ .*Linux\ Comunicações.* ]] || ( [[ "$os" =~ .*Linux\ Comunicações.* ]] && [[ "$obj" != "null" ]] )

}

function memory() {
    obj=$(cat inventory.json | jq -r '.data_inventory.memory')
    [[ "$obj" -eq "$obj" ]] && [[ "$obj" != "null" ]]
}

function os_distro() {
    obj=$(cat inventory.json | jq -r '.data_inventory.os_distro')
    [[ "$obj" != "null" ]]
}

function os_kernel() {
    obj=$(cat inventory.json | jq -r '.data_inventory.os_kernel')
    [[ "$obj" != "null" ]]
}

function os_type() {
    obj=$(cat inventory.json | jq -r '.data_inventory.os_type')
    [[ "$obj" != "null" ]]
}

function processor() {
    obj=$(cat inventory.json | jq -r '.data_inventory.processor')
    [[ "$obj" != "null" ]]
}

setup() {
    ./../bin/agent.run  --quiet | head -n -1  > export.json
    pt1=$(cat export.json | head -n -9)
    echo $pt1 > inventory.json
    pt2=$(cat export.json | tail -n 9)
    echo $pt2 > net.json
    [ -s export.json ]
    [ -s inventory.json ]
    [ -s net.json ]
    cat export.json
}

teardown() {
     rm -f export.json
     rm -f inventory.json
     rm -f net.json
}

@test "Amount Users" {
    run amount_users
    [ "$status" -eq 0 ]
}

@test "MAC" {
    run mac_address
    [ "$status" -eq 0 ]
}

@test "Machine Type" {
    run machine_type
    [ "$status" -eq 0 ]
}

@test "Memory" {
    run memory
    [ "$status" -eq 0 ]
}

@test "OS Distro" {
    run os_distro
    [ "$status" -eq 0 ]
}

@test "OS Kernel" {
    run os_kernel
    [ "$status" -eq 0 ]
}

@test "OS Type" {
    run os_type
    [ "$status" -eq 0 ]
}

@test "Processor" {
    run processor
    [ "$status" -eq 0 ]
}
